
#include "hcat.h"
#include "hdstr.h"
#include <stdio.h>
#include "hmalloc.h"
#include <string.h>
#include "hdir.h"
#include "hlow.h"
#include "hfname.h"
#include "hdio.h"
#include "hsamio.h"

char catflag;

void getfiletypename(s_fsam *myfsam,char *pp)
// fill a passed string with a description of the file 
// whose fsam is passed used in DIR etc
{
 uint  type;
 char *tmp,*dt;
 uchar *info;
 long start,length,adr;
 long pg,hi,lo;
 s_time *dtime;
 

 if (myfsam->f_fib.f_type & ft_archive) strcat(pp,"+"); 
    else strcat(pp," ");
 if (myfsam->f_fib.f_type & ft_protected) strcat(pp,"*"); 
    else strcat(pp," ");

 strncat(pp,myfsam->f_fib.f_name,10);
 strcat(pp,"\027\015\1"); // tab 11;
 type = (myfsam->f_fib.f_type & 0x1F);
 tmp = calloc(1,30);
 dt  = calloc(1,30);

 info = (uchar*)&myfsam->f_fib.f_info;
 dtime= (s_time*)&myfsam->f_fib.f_upd;

 pg = info[31]&0x1f; lo=info[32]; hi=info[33]&0x7f;
 adr    =   16384 * pg + 256*hi + lo;
 
 pg = info[34]&0x1f; lo=info[35]; hi=info[36]&0x7f;
 length =   16384 * pg + 256*hi + lo;
 
 pg = info[37]&0x1f; lo=info[38]; hi=info[39]&0x7f;
 if (pg != 0x1f) start  = 16384*pg + 256*hi + lo;
 else start = 0;

 if (dtime->t_mm)
 {
	sprintf(dt," %2.2d/%2.2d/%2.2d %2.2d:%2.2d:%2.2d",
 		dtime->t_DD,dtime->t_MM,dtime->t_YY,
 		dtime->t_hh,dtime->t_mm,dtime->t_ss);
 }
 else
 {
	 sprintf(dt,"                  ");
 }


 sprintf(tmp,"  %ld\r",length);
 
 switch (type)
 {
  case 19: 
  {
	  strcat(pp,"CODE     ");
	  
	  sprintf(tmp,"  %ld,%ld,%ld\r",adr+16384,length,start);
	  break;
  }
  case 16: 
  {
	  strcat(pp,"BASIC    ");
	  sprintf(tmp,"  %ld,%ld\r",length,start);
	  break;
  }
 //   case 0:  strcat(pp,"Erased   ");break;
 //   case 1:  strcat(pp,"ZXBasic  ");break;
 //   case 2:  strcat(pp,"ZXarray  ");break;
 //   case 3:  strcat(pp,"ZXarray$ ");break;
 //   case 4:  strcat(pp,"ZXcode   ");break;
 //   case 5:  strcat(pp,"ZXSnp48  ");break;
 //   case 6:  strcat(pp,"ZXmdrv   ");break;
 //   case 7:  strcat(pp,"ZXscreen ");break;
 //   case 8:  strcat(pp,"ZXSpecial");break;
 //   case 9:  strcat(pp,"ZXsnp128 ");break;
  case 10: strcat(pp,"Opentype ");break;
 //   case 11: strcat(pp,"ZXexecute");break;
 //   case 12: strcat(pp,"UDOS dir ");break;
 //   case 13: strcat(pp,"UDOS cre ");break;
  case 17: strcat(pp,"ARRAY    ");break;
  case 18: strcat(pp,"ARRAY$   ");break;
  case 20: strcat(pp,"SCREEN   ");break;
 //   case 21: strcat(pp,"SAMDOSdir");break;
 //   case 28: strcat(pp,"HDos     ");break;
  case 29: strcat(pp,"Directory");break;
 //   case 30: strcat(pp,"Disk img ");break;
  case 31: strcat(pp,"Temp     ");break;
  default: strcat(pp,"What     ");
 }
 strcat(pp,dt);
 strcat(pp,tmp);
 free(tmp);
 free(dt);
}

void catalog(char full, char *path)
// catalog the current dir a hard drive
// if full != 0 then do a full listing
// if name == 0 then only print files names that match
{
 long  se,freesp,count;
 int   i,col;
 int   dirnum;
 char  filename[11];
 s_fsam *myavl,*myfsam;
 s_dir  *mydir;
 s_label *mylab;
 char   *str;

 catflag = 1;
 
 if ((dirnum = getdirnum(path)) == error)
 {
  hderror(BADPATH);
 }
 
 strcpy(filename,getfilepart(path));
 padname(filename);

 if (!memcmp(filename,blank,10)) *filename = wild2;

 count = 0;

 if ((mylab = calloc(1,sizeof(s_dir))) == 0) hderror(OUTOFMEMORY);
 hdread(mylab,LABEL); // get label
 printf("Volume is %19s",(char*)mylab);     // print disk name
 free(mylab);
 
 if (dirnum)
 {
  // print dir name
  printf("\rDirectory of %s",path);	 
 }
 printf("\r\r");

 if ((myfsam = calloc(1,sizeof(s_fsam))) == 0) hderror(OUTOFMEMORY);
 if ((mydir = calloc(1,sizeof(s_dir))) == 0) hderror(OUTOFMEMORY);
 col=0;
 se=DIRSTART;  // start of directory
 do
 {
  hdread(mydir,se);
  se = mydir->d_next;
  for (i=0;i<n_head;i++)
  {
   if (mydir->d_head[i].h_fsam)
   if (mydir->d_head[i].h_dir == dirnum)
   { // found a file in this directory
    if ((filenamecmp(mydir->d_head[i].h_name,filename))==ok)
    {
     hdread(myfsam,mydir->d_head[i].h_fsam);
     if ((myfsam->f_fib.f_type & ft_hidden) == 0)   
     {
      if (full) // full list
      {
       if ((str = calloc(1,100)) == 0) hderror(OUTOFMEMORY);
       getfiletypename(myfsam,str);
       printf("%s",str);
       free(str);
       count++;
      }
      else // short list
      {
       if (col > 30) col=0; 
       {
        printf("%c%c%c%10.10s",23,col,0,mydir->d_head[i].h_name);
        count++;
        col += 11;
       }
      }
     }
    }
   }
  }
 } while (se);
 free(myfsam);
 free(mydir);

 // print number of files and amount of free space
 printf("\r %ld file(s)\r",count);
 se = AVLSTART;  // start of free chain
 freesp=0L;
 if ((myavl = calloc(1,sizeof(s_fsam))) == 0) hderror(OUTOFMEMORY);
do
 {
  hdread(myavl,se);	 
  se = myavl->f_next;	 
  for (i=0;i<n_run;i++)
  {
   freesp += (myavl->f_runen[i] - myavl->f_runst[i]);	  
  }	
 } while(se);
 freesp *= 512L;
 printf("%ld bytes free\r",freesp);
 free(myavl);
 catflag = 0;
}
